# Gluon-OCR Toolkit
Gluon-OCR provides implementations of deep learning models in text detection and recognition.

## Supported Models
- Various text detection algorithms: EAST, CLRS, DB
- Various text recognition algorithms: CRNN, RARE

## Tutorials
- [Installation](./doc/installation.md)
- [Quick Start](./doc/quickstart.md)
- Algorithm introduction
    - [Text Detection Algorithm](#TEXTDETECTIONALGORITHM)
    - [Text Recognition Algorithm](#TEXTRECOGNITIONALGORITHM)
    - [END-TO-END OCR Algorithm](#ENDENDOCRALGORITHM)
- Model training/evaluation
    - [Text Detection](./doc/detection.md)
    - [Text Recognition](./doc/recognition.md)
    - [End2End](#END2END)
- Deployment
    - [Python Inference](./scripts/deploy/python_infer/readme.md)
    - [C++ Inference](./scripts/deploy/cpp_infer/readme.md)
- Datasets
    - [General OCR Datasets(Chinese/English)](https://github.com/PaddlePaddle/PaddleOCR/tree/develop/doc/doc_en/datasets_en.md)
    - [HandWritten_OCR_Datasets(Chinese)](https://github.com/PaddlePaddle/PaddleOCR/tree/develop/doc/doc_en/handwritten_datasets_en.md)
    - [Various OCR Datasets(multilingual)](https://github.com/PaddlePaddle/PaddleOCR/tree/develop/doc/doc_en/vertical_and_multilingual_datasets_en.md)
    - [Data Annotation Tools](https://github.com/PaddlePaddle/PaddleOCR/tree/develop/doc/doc_en/data_annotation_en.md)
    - [Data Synthesis Tools](https://github.com/PaddlePaddle/PaddleOCR/tree/develop/doc/doc_en/data_synthesis_en.md)

## Reference
[1]. https://github.com/PaddlePaddle/PaddleOCR \
[2]. https://github.com/dmlc/gluon-cv \
[3]. [EAST: an efficient and accurate scene text detector](https://arxiv.org/abs/1704.03155) \
[4]. [Real-time Scene Text Detection with Differentiable Binarization](https://arxiv.org/abs/1911.08947) \
[5]. [Multi-Oriented Scene Text Detection via Corner Localization and Region Segmentation](https://arxiv.org/abs/1802.08948) \
[6]. [An End-to-End Trainable Neural Network for Image-based Sequence Recognition and Its Application to Scene Text Recognition](https://arxiv.org/abs/1507.05717) \
[7]. [Robust Scene Text Recognition with Automatic Rectification](https://arxiv.org/abs/1603.03915v1) 

